<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>homework7_filter-array</title>
</head>

<body>
  <script>
    'use strict';

    const arr = [3, 2, 5, 'q', 'w', 'e', null, { name: 'myName' }, [1, 2, 3], true, false, undefined,]; //12

    function filterBy(arr, type) {
      let temp = [];

      return temp = arr.filter(item => {
        if (type === 'object') {
          return typeof item !== type || item === null || Array.isArray(item);
        } else if (type === 'null') {
          return item !== null;
        } else if (type === 'array') {
          return !Array.isArray(item);
        } else {
          return typeof item !== type;
        }
      });
    }

    // const result = filterBy(arr, 'null');
    const result = filterBy(arr, 'array');
    // const result = filterBy(arr, 'object');
    // const result = filterBy(arr, 'string');
    // const result = filterBy(arr, 'number');
    // const result = filterBy(arr, 'boolean');
    // const result = filterBy(arr, 'undefined');
    console.log(result);

  </script>
</body>

</html>